
{bpascal.ru}
uses graph,crt;

type point = record
               x,y:integer;
             end;
     arr = array[1..65520 div sizeof(point)] of point;
     arrp = ^arr;
var xmin,xmax,ymin,ymax:word;

procedure drawfigure(var a:arrp;p:point;l:word;n:byte);
var i,j:byte;

begin
  a^[1].x:=p.x;
  a^[1].y:=p.y;
  a^[3].x:=a^[1].x+l;
  a^[3].y:=a^[1].y;
  a^[2].x:=a^[1].x+round(l/2);
  a^[2].y:=a^[1].y-round(sqrt(3)/2*l);
  j:=1;
  for i:=1 to n do begin
    a^[3*i+1].x:=(a^[j].x+a^[j+1].x) div 2;
    a^[3*i+1].y:=(a^[j].y+a^[j+1].y) div 2;
    a^[3*i+2].x:=(a^[j+1].x+a^[j+2].x) div 2;
    a^[3*i+2].y:=(a^[j+1].y+a^[j+2].y) div 2;
    a^[3*i+3].x:=(a^[j].x+a^[j+2].x) div 2;
    a^[3*i+3].y:=(a^[j].y+a^[j+2].y) div 2;
    j:=j+3;
  end;

  for i:=0 to n do
    begin
      line(a^[3*i+1].x,a^[3*i+1].y,a^[3*i+2].x,a^[3*i+2].y);
      line(a^[3*i+2].x,a^[3*i+2].y,a^[3*i+3].x,a^[3*i+3].y);
      line(a^[3*i+1].x,a^[3*i+1].y,a^[3*i+3].x,a^[3*i+3].y);
    end;
end;

procedure swap(var p1,p2:point;var c1,c2:byte);
var t1:point;
    t2:byte;
begin
  t1:=p1;
  p1:=p2;
  p2:=t1;
  t2:=c1;
  c1:=c2;
  c2:=t2;
end;

function getcode(p:point):byte;
begin
  getcode:=byte (p.x<xmin) shl 3 or byte (p.x>xmax) shl 2 or byte(p.y<ymin) shl 1 or byte (p.y> ymax);
end;

procedure cutline(p1,p2:point);
var c1,c2,f:byte;
    x,y:word;
begin
  f:=0;
  c1:=getcode(p1);
  c2:=getcode(p2);
  if (c1=0)and(c2=0) then
    begin
      line(p1.x,p1.y,p2.x,p2.y);
      exit;
    end;
  while (c1<>0) or (c2<>0) do
    begin
      if (c1 and c2 <> 0) then exit
        else
        if c1<>0 then
          begin
            if (c1 and 8 <> 0) then
              begin
                x:=xmin;
                f:=1;
              end;
            if (c1 and 4 <> 0) then
              begin
                x:=xmax;
                f:=1;
              end;
            if (c1 and 2 <> 0) then  y:=ymin;
            if (c1 and 1 <> 0) then  y:=ymax;
            if f=0 then
              begin
                p1.x:=p1.x+((y-p1.y)*(p2.x-p1.x)) div (p2.y-p1.y);
                p1.y:=y;
                c1:=getcode(p1);
              end;
            if f=1 then
              begin
                p1.y:=p1.y+(x-p1.x)*(p2.y-p1.y) div (p2.x-p1.x);
                p1.x:=x;
                c1:=getcode(p1);
                f:=0;
              end;
          end
          else
            swap(p1,p2,c1,c2);
    end;
  line(p1.x,p1.y,p2.x,p2.y);
end;

procedure cutfigure(a:arrp;n:byte);
var i:byte;
begin
  for i:=0 to n do begin
    cutline(a^[3*i+1],a^[3*i+2]);
    cutline(a^[3*i+2],a^[3*i+3]);
    cutline(a^[3*i+1],a^[3*i+3]);
  end;
end;

var a:arrp;
    p1:point;
    gd,gm:integer;
    l:word;
    n:byte;
begin
  clrscr;
  write(' x1,y1,l,n: ');
{  read(p1.x,p1.y,l,n);}
  p1.x:=200; p1.y:=300; l:=300; n:=4;
  write(' न ᥪ饩 㦭: ');
{  read(xmin,ymin,xmax,ymax);}
  xmin:=220; ymin:=200; xmax:=415; ymax:=250;
  gd:=detect;
  initgraph(gd,gm,'c:\bp\bgi');
  getmem(a,(3*n+3)*sizeof(point));
  drawfigure(a,p1,l,n);
  readkey;
  cleardevice;
  rectangle(xmin,ymin,xmax,ymax);
  cutfigure(a,n);
  readkey;
  freemem(a,(3*n+3)*sizeof(point));
  closegraph;
end.